
QGIS Application - Bug report #13708

Nested symbology layer not displayed anymore on qgis server 2.10.1

2015-10-29 06:44 AM - Nicolas Liaudat

Status: Closed

Priority: Severe/Regression

Assignee: Matthias Kuhn

Category: Symbology

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: fixed/implemented

Crashes QGIS or corrupts data:No Copied to github as #: 21735

Description

Hi,

Nested symbology is not rendered on qgis server 2.10.1 (debian jessie).

Please have a look at the screenshots.

Regards

Associated revisions

Revision d796ade3 - 2016-01-18 04:37 PM - Matthias Kuhn 

Also render all parent features on refined rules

Fix #13708

History

#1 - 2015-10-29 10:27 PM - Nyall Dawson

Can you test with 2.12? 2.10 won't receive any further updates.

#2 - 2015-10-29 10:27 PM - Nyall Dawson

- Status changed from Open to Feedback

#3 - 2015-10-29 11:31 PM - Nicolas Liaudat

Same effect in qgis 2.12 Desktop, so I mean the same for 2.12 server

#4 - 2015-10-30 02:27 AM - Nyall Dawson

So to clarify, you also see this in desktop? Can you share a sample project?

#5 - 2015-10-30 03:12 AM - Nicolas Liaudat

- File Bug_report_13708.zip added
Here you'll find a test project. 

You can compare the nested and flat styles.

Regards

#6 - 2015-11-06 11:43 AM - Giovanni Manghi

- Operating System deleted (debian jessie)

- Status changed from Feedback to Open

- Affected QGIS version changed from 2.10.1 to master

It seems confirmed to me on master, if it worked ok in previous qgis releases please tag this as blocker (regression).

#7 - 2015-11-16 04:45 AM - Nicolas Liaudat

Hi, this is a confirmed regression. I have no rights to change tags, could you change that issue to blocker ?

Regards

#8 - 2015-11-16 04:47 AM - Giovanni Manghi

- Priority changed from Normal to Severe/Regression

#9 - 2016-01-16 12:44 AM - Paolo Cavallini

Still true in current master (would be 2.14 LTR)?

#10 - 2016-01-16 04:36 AM - Sebastian Dietrich

- Category changed from QGIS Server to Symbology

Yes, I can confirm it is still true in current master (commit:1cd4570136344caafebbe911bbe797ddbc87a56a).

#11 - 2016-01-16 07:48 AM - Sebastian Dietrich

Ok, I tracked it down to QgsVectorLayerRenderer

  mRendererV2->startRender( mContext, mFields );

  QString rendererFilter = mRendererV2->filter( mFields );

QgsRuleBasedRendererV2::startRender() sets the filter returned by QgsRuleBasedRendererV2::filter() by combining the filters for the individual rules. This

combining is done wrong.

Example:

    -  Rule 1 (Filter "A" = 1)

        -  Rule 1.1 (Filter "B" = 2)

    -  Rule 2 (Filter "A" = 3)

The rendererFilter will contain:

(("A" = 1) AND ("B" = 2)) OR ("A" = 3)
https://github.com/qgis/QGIS/blob/1cd4570136344caafebbe911bbe797ddbc87a56a/src/core/qgsvectorlayerrenderer.cpp#L146-L148
https://github.com/qgis/QGIS/blob/1cd4570136344caafebbe911bbe797ddbc87a56a/src/core/symbology-ng/qgsrulebasedrendererv2.cpp#L822
https://github.com/qgis/QGIS/blob/1cd4570136344caafebbe911bbe797ddbc87a56a/src/core/symbology-ng/qgsrulebasedrendererv2.cpp#L887


But it should contain:

("A" = 1) OR ("A" = 3)

#12 - 2016-01-16 10:39 AM - Sebastian Dietrich

- Status changed from Open to In Progress

- Assignee set to Sebastian Dietrich

- % Done changed from 0 to 20

#13 - 2016-01-16 11:50 AM - Sebastian Dietrich

The regression occurred in commit:1d7a6a4909e70fe03251c021336e51d311c02116.

Please note:

As far as I can see it never made it to QGIS 2.10.1. I even checked out the release-2_10 branch

(commit:746af79428668bdb727f11c561ad0e0639316f3d) and tested with the data attached to this ticket, everything ok.

#14 - 2016-01-20 08:21 AM - Anonymous

- Status changed from In Progress to Closed

Fixed in changeset commit:"d796ade35d6dd95d23d3f1f5edbb817718f0d140".

#15 - 2016-01-20 12:21 PM - Sebastian Dietrich

- % Done changed from 20 to 100

- Assignee changed from Sebastian Dietrich to Matthias Kuhn

- Resolution set to fixed/implemented

Files

rendering_working.png 41.1 KB 2015-10-29 Nicolas Liaudat

rendering_not-working.png 22 KB 2015-10-29 Nicolas Liaudat

config_working.png 10 KB 2015-10-29 Nicolas Liaudat

config_not-working.png 6.91 KB 2015-10-29 Nicolas Liaudat

Bug_report_13708.zip 123 KB 2015-10-30 Nicolas Liaudat

2025-04-27 3/3


